unit gNfrPush;

// who the heck is pushing all these packets?  lets watch em..

(****************************************************************
Copyright (C)2000, Michael Ax. Created 2000. All rights reserved.
License to copy, use also for making and using derivative works
of this software is granted provided that that such works are
identified as "derived from the GnutViewer project" in all material
mentioning or referencing the derived work. Michael Ax makes no
representations concerning either the merchantability of this software
or the suitability of this software for any particular purpose. It is
provided "as is" without express or implied warranty of any kind.
These notices must be retained in this documentation and/or software.
*****************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gNutFrame, gNutella, StdCtrls, ExtCtrls;

type
  TgNutPush = class(TGnutellaCustomFrame)
    Panel1: TPanel;
    Panel2: TPanel;
    ListBox1: TListBox;
    Memo1: TMemo;
    Splitter1: TSplitter;
    cbTrackPush: TCheckBox;
    Label1: TLabel;
    procedure cbTrackPushClick(Sender: TObject);
  private
    { Private declarations }
    bTrackPush: boolean;
    procedure PushRequest(Sender: TObject; ppr:Pgnutella_push_req);
  public
    { Public declarations }
    procedure Init(aGnuTella: TGnuTellaTrans); override;
    end;

var
  gNutPush: TgNutPush;

implementation

{$R *.DFM}

uses
  WinSock, gNutUtil;

procedure TgNutPush.Init(aGnuTella: TGnuTellaTrans);
begin
  inherited Init(aGnuTella);
  cbTrackPushClick(nil);
end;

procedure TgNutPush.PushRequest(Sender: TObject; ppr:Pgnutella_push_req);
var
  i,n: integer;
  a1,a2: string;
  ia: in_addr;
begin
  if not bTrackPush then
    exit;
  TimingOn(Label1);
{
  gnutella_push_req = packed record
    ClientID128:  TGUID;
    FileIndex:    integer;
    RequestIP:    integer;
    RequestPort:  WORD;
  end;
}
  with ppr^ do begin
    a1:= GUIDToString(ClientID128);
    ia.S_addr := RequestIP;
    a2:= string(inet_ntoa(ia))+':'+inttostr(Requestport);
    a2:= a2+'@'+inttostr(FileIndex);
    end;

  with listbox1.Items do begin
    i:=indexof(a1);
    if i=-1 then
      add(a1);
    end;

  a2:= a2+';'+inttostr(i);//+' '+a1;
  with memo1.lines do begin
    i:= indexof(a2);
    if i>-1 then
      //move(i,0)
    else begin
      insert(0,a2);
      if Count>50 then
        Delete(pred(Count));
      end;
    end;
//  Entering('PushRequest','');
  TimingOff;
end;

procedure TgNutPush.cbTrackPushClick(Sender: TObject);
begin
  inherited;
  bTrackPush:= cbTrackPush.Checked;
  with gNutella do
    if bTrackPush then
      OnPushRequest:= PushRequest
    else
      OnPushRequest:= nil;
end;

end.
