unit gNfrSearch;

// what are we searching for?

(****************************************************************
Copyright (C)2000, Michael Ax. Created 2000. All rights reserved.
License to copy, use also for making and using derivative works
of this software is granted provided that that such works are
identified as "derived from the GnutViewer project" in all material
mentioning or referencing the derived work. Michael Ax makes no
representations concerning either the merchantability of this software
or the suitability of this software for any particular purpose. It is
provided "as is" without express or implied warranty of any kind.
These notices must be retained in this documentation and/or software.
*****************************************************************)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  gNutFrame, gNutella, StdCtrls, ExtCtrls;

type
  TgNutSearch = class(TGnutellaCustomFrame)
    Memo1: TMemo;
    Panel1: TPanel;
    Button2: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure Button2Click(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
  private
    { Private declarations }
    procedure SrchRespBegin(const HostIP: String; HostPort: Word; Speed: Integer);
    procedure SrchRespItem(FileIdx, FileSize, HostSpeed: Integer; const FileName: String);
    procedure SrchRespEnd(ClientID128: TGUID);
  public
    { Public declarations }
    procedure Init(aGnuTella: TGnuTellaTrans); override;
    procedure Entering(const Sender,aText: String);
    end;

var
  gNutSearch: TgNutSearch;

implementation

{$R *.DFM}


procedure TgNutSearch.Entering(const Sender,aText: String);
begin
  with memo1.lines do begin
    add(Sender);
    if Count>nLines then
      Delete(0);
    if aText<>'' then begin
      Add('  ['+aText);
      if Count>nLines then
        Delete(0);
      end;
    end;
end;

procedure TgNutSearch.Init(aGnuTella: TGnuTellaTrans);
begin
  inherited Init(aGnuTella);
  with gNutella do begin
    OnSrchRespBegin:= SrchRespBegin;
    OnSrchRespEnd:= SrchRespEnd;
    OnSrchRespItem:= SrchRespItem;
    end;
end;

procedure TgNutSearch.SrchRespBegin(const HostIP: String; HostPort: Word; Speed: Integer);
begin
  Entering('SrchRespBegin',hostip);
end;

procedure TgNutSearch.SrchRespEnd(ClientID128: TGUID);
begin
  Entering('SrchRespEnd',GUIDToString(ClientID128));
end;

procedure TgNutSearch.SrchRespItem(FileIdx, FileSize, HostSpeed: Integer; const FileName: String);
begin
  Entering('SrchRespItem',filename);
end;


procedure TgNutSearch.Button2Click(Sender: TObject);
begin
  inherited;
  with GnuTella do
    BeginSearch(edit1.text,strtointdef(edit2.text,0));
end;

procedure TgNutSearch.Edit2Exit(Sender: TObject);
begin
  inherited;
  with edit2 do
    text:=inttostr(strtointdef(text,0));
end;

end.
